﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Windows.Forms;
using HeuristicLab.Core.Views;
using HeuristicLab.MainForm;
using HeuristicLab.MainForm.WindowsForms;

namespace HeuristicLab.Clients.Hive.Views.Administration {
  [View("SlaveView")]
  [Content(typeof(Slave), IsDefaultView = true)]
  public partial class SlaveView : ItemView {
    public new Slave Content {
      get { return (Slave)base.Content; }
      set { base.Content = value; }
    }

    public SlaveView() {
      InitializeComponent();
    }

    #region Register Content Events
    protected override void DeregisterContentEvents() {
      base.DeregisterContentEvents();
    }
    protected override void RegisterContentEvents() {
      base.RegisterContentEvents();
    }
    #endregion

    protected override void OnContentChanged() {
      base.OnContentChanged();
      if (Content == null) {
        txtName.Clear();
        txtCPU.Clear();
        txtDetailsDescription.Clear();
        txtMemory.Clear();
        txtOS.Clear();
        txtSlaveState.Clear();
        txtLastHeartbeat.Clear();
        txtFreeMemory.Clear();
        txtId.Clear();
      } else {
        txtName.Text = Content.Name;
        txtCPU.Text = Content.Cores.ToString() + " Cores @ " + Content.CpuSpeed.ToString() + " Mhz, Arch.: " + Content.CpuArchitecture.ToString();
        txtDetailsDescription.Text = Content.Description;
        txtMemory.Text = Content.Memory.ToString();
        txtOS.Text = Content.OperatingSystem;
        txtSlaveState.Text = Content.SlaveState.ToString();
        txtLastHeartbeat.Text = Content.LastHeartbeat.ToString();
        txtFreeMemory.Text = Content.FreeMemory.ToString();
        txtId.Text = Content.Id.ToString();
      }
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
    }
  }
}
